%% Gear box shift control function
% This function takes the current gear, engine efficiency, engine speed and
% demanded load into consideration to determine the proper gear position
% during the drive cycle.
function gear = decideShift(gear,curr_eng_spd,a_req) 

% Set the global variables for use amonst the functions and master files
global GB FD rw eta_gb max_gear EFFnew SPEED TORQUE max_spd a_lim min_spd

% Shifting logic
% eff_up=NaN;eff_dwn=NaN;
% if gear<max_gear    % As long as we are not in the top gear ...
%     espd_up = v_prof(i+1,2)*GB(gear+1,2)*FD/rw; % Calculate the next engine speed if we up-shifted
%     etrq_up = Ftr(i+1)*GB(gear+1,2)*FD/rw*1/eta_gb; % and the next torque
%     % Find the engine efficiency at the upshift operating point
%     [val,ind_spd]=min(espd_up-SPEED(1,:));
%     [val,ind_trq]=min(etrq_up-TORQUE(:,1));
%     eff_up = EFFnew(ind_trq,ind_spd); % Check the efficiency for an upshift
% end
% if gear>1   % As long as the gear is not in first ... 
%     espd_dwn = v_prof(i+1,2)*GB(gear-1,2)*FD/rw; % Calculate the next engine speed if we down-shifted
%     etrq_dwn = Ftr(i+1)*GB(gear-1,2)*FD/rw*1/eta_gb; % and the next torque
%     % Find the engine efficiency at the downshift operating point
%     [val,ind_spd]=min(espd_dwn-SPEED(1,:));
%     [val,ind_trq]=min(etrq_dwn-TORQUE(:,1));
%     eff_dwn = EFFnew(ind_trq,ind_spd); % Check the efficiency for an down-shift
% end
% If the efficiency improves from an up-shift OR the current eng-speed is
% too high AND the current gear is not in the max position -> proceed with
% an up-shift.
if (curr_eng_spd > max_spd) && gear<max_gear
    gear = gear+1;
end
% If the efficiency improves from a down-shift OR the current eng-speed is
% too low OR the requested acceleration can't be met in the current gear 
% AND the current gear is not in first -> proceed with a down-shift.
if (curr_eng_spd < min_spd || a_req>a_lim) && gear>1
    gear = gear-1;
end

            